// Saeed Mahani
// MAT 259 - Data Visualization
// W13

import de.bezier.data.sql.*;

MySQL msql;
int monthCount = 7*12; 
int languageCount = 6;
int[][] data = new int[monthCount][languageCount];
String[] languages = {"iOS", "Android", "HTML", "JavaScript", "Java", "C"};
String[] langTypes = {"Mobile", "Web", "Core"};

String DL = ","; //the DELIMITER
PFont languageFont;
PFont langTypeFont;
PFont yearFont;

void setup() {
 // smooth();
  
  String q = "select \n  year(activity.o) as \'Year\',\n  month(activity.o) as \'Month\',\n  sum(case when (keyword.keyword = \'c\') then 1 else 0 end) as \'C\',\n  sum(case when (keyword.keyword = \'java\') then 1 else 0 end) as \'Java\',\n  sum(case when (keyword.keyword = \'javascript\') then 1 else 0 end) as \'JavaScript\',\n  sum(case when (keyword.keyword = \'html\') then 1 else 0 end) as \'HTML\',\n  -- sum(case when (keyword.keyword = \'python\') then 1 else 0 end) as \'Python\',\n  sum(case when (keyword.keyword = \'android\') then 1 else 0 end) as \'Android\',\n  sum(case when (keyword.keyword = \'ios\') then 1 else 0 end) as \'iOS\' \nfrom \n  keyword, title, collection, item, subject, activity\nwhere\n  keyword.bib = title.bib and\n  item.bib = title.bib and\n  item.item = collection.item and\n  item.bib = subject.bib and\n  activity.bib = item.bib and\n  (subject.subject like \'%programming%\' or subject.subject like \'%computer%\' or subject.subject like \'%software%\' or subject.subject like \'%development%\') and\n  (keyword.keyword = \'java\' or keyword.keyword = \'javascript\' or keyword.keyword = \'python\' or keyword.keyword = \'android\' or keyword.keyword = \'ios\' or keyword.keyword = \'c\' or keyword.keyword = \'html\') and\n  year(activity.o) >= 2006 and year(activity.o) <= 2012\ngroup by year(activity.o), month(activity.o);";
  
  // Prep canvas
  size(1024,768);
  colorMode(HSB, 360, 100, 100);
  
  // Load fonts
  languageFont = createFont("HelveticaNeue", 20);
  langTypeFont = createFont("HelveticaNeue", 46);
  yearFont = createFont("HelveticaNeue", 15);
  
  msql = new MySQL( this, "tango.mat.ucsb.edu", "spl1", "mat259", "V1sual1zat1on" ); //host, database, user, password
  if ( msql.connect() ) { 
    msql.query(q);
    int row = 0;
    while (msql.next ()) {
      int col = 1;
      //println(msql.getInt(col+2) + DL + msql.getInt(col+3) + DL + msql.getInt(col+4) + DL + msql.getInt(col+5) + DL + msql.getInt(col+6) + DL + msql.getInt(col+7) + DL + msql.getInt(col+8));
      for (col = 0; col < languageCount; col++) {
        data[row][col] = msql.getInt(col+3);
      }
      row += 1;
    }
  }
  else {
    println("MySQL Connection failed!");
  }
  String[] fontList = PFont.list();
  println(fontList);
}


int saturation = 75;
int brightness = 85;

int barWidth = 6;
int topMargin = 40;
int bottomMargin = 40;
int leftMargin = 40;
int rightMargin = 40;

//float barScale = 0.021;  // 
float barScale = 0.2;

void draw() {
  noLoop();
  noStroke();
  background(355);
  textFont(yearFont);
  textAlign(CENTER, CENTER);
  
  // For each month between Jan 2006 and Jan 2012
  for (int i=0; i < monthCount; i++) {
    
    //int year = 2006+i;
    float barSpacing = float(width - leftMargin - rightMargin - monthCount*barWidth)/(monthCount-1);
    float pos = barWidth*i + barSpacing*i + leftMargin;

    float yPos = height-bottomMargin;
    for (int langIndex = 0; langIndex < languageCount; langIndex++) {
      fill(float(langIndex)/languageCount*250, saturation, brightness);
      float subBarHeight = data[i][langIndex] * barScale;
      yPos -= subBarHeight;
      rect(pos, yPos, barWidth, subBarHeight);
    }
    
    // Year labels
    if (i%12==0) {
      int year = i/12+2006;
      fill(255, 0, 55);
      text(year, leftMargin+i*barWidth+(i-1)*barSpacing+barWidth*6+barSpacing*6, height-bottomMargin/2.0-2);
    }
  }
  
  // Language Type Labels
  textFont(langTypeFont);
  float keyOffset = textWidth("Mobile");
  textAlign(RIGHT, CENTER);
  for (int i = 0; i < 3; i++) {
    fill(255, 0, 50+((i+1)%2*14));
    text(langTypes[i], leftMargin+keyOffset, topMargin+40*i+15);
  }
  
  // Language labels
  textFont(languageFont);
  textAlign(LEFT, TOP);
  for (int langIndex = 0; langIndex < languageCount; langIndex++) {
    fill(float(languageCount-langIndex-1)/languageCount*250, saturation, brightness);
    rect(leftMargin+4+keyOffset, topMargin+20*langIndex, barWidth, 20);
    
    fill(255, 0, 50+((langIndex/2+1)%2*14));
    text(languages[langIndex], leftMargin+barWidth+8+keyOffset, topMargin+20*langIndex);
  }
}




